﻿using UnityEngine;
using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;
using System.Collections;

namespace Mod
{
    public class Mod
    {

        public static void Main()
        {
            //by JulianMagicCraft


            ModAPI.Register(
new Modification()
{
    OriginalItem = ModAPI.FindSpawnable("Rod"),
    NameOverride = "MultiLife Injector",
    DescriptionOverride = "Shoot any Entity with this portable Injector to give it extra Lifes.",
    CategoryOverride = ModAPI.FindCategory("Machinery"),
    ThumbnailOverride = ModAPI.LoadSprite("MultiLifeInjectoor.png"),
    AfterSpawn = (Instance) =>
    {
        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("MultiLifeInjectoor.png");
       var multikulti = Instance.AddComponent<MultiLifeInjectorRay>();
        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

        Instance.FixColliders();
        Instance.AddComponent<UseEventTrigger>().Action = () =>
        {
            multikulti.Activation();
        };



    }

        }
);

        }



        public class MultiLifeInjectorRay : MonoBehaviour
        {
            public float maxDistance = 100f;
            public Color lineColor = Color.white;
            public LineRenderer lineRenderer;
            public RaycastHit2D hit;

            public void Start()
            {
                lineRenderer = gameObject.AddComponent<LineRenderer>();
                lineRenderer.startWidth = 0.01f;
                lineRenderer.endWidth = 0.01f;
                lineRenderer.material = new Material(Shader.Find("Sprites/Default"));
                lineRenderer.positionCount = 2;
                lineRenderer.startColor = lineColor;
                lineRenderer.endColor = lineColor;
            }

            public void Update()
            {
                lineRenderer.SetPosition(0, transform.position);
                hit = Physics2D.Raycast(transform.position, transform.up, maxDistance);
                if (hit.collider != null)
                {
                    if (hit.collider.gameObject != gameObject)
                    {
                        lineRenderer.SetPosition(1, hit.point);
                    }
                    else
                    {
                        lineRenderer.SetPosition(1, transform.position + (transform.up * maxDistance));
                    }
                }
                else
                {
                    lineRenderer.SetPosition(1, transform.position + (transform.up * maxDistance));
                }


            }

          

            public void Activation()
            {
                hit = Physics2D.Raycast(transform.position, transform.up, maxDistance);
                if (hit.collider != null)
                {
                    if (hit.collider.gameObject != gameObject)
                    {
                        DoTheThing(hit.collider.gameObject);
                    }

                }
            }

            public void DoTheThing(GameObject Nice)
            {
               
                    var lim = Nice.GetComponent<LimbBehaviour>();
                    var per = lim.Person;
                    var heady = per.transform.Find("Head");

                if (heady.gameObject.GetComponent<MultiLifeJmc>() == null)
                {
                   var m = heady.gameObject.AddComponent<MultiLifeJmc>();
                    m.otherGameObject = Nice;
                } else
                {
                    heady.gameObject.GetComponent<MultiLifeJmc>().MultiLifeCounter++;
                }
  
              
            }
        }

        public class MultiLifeJmc : MonoBehaviour
        {
            public GameObject otherGameObject;
            public Vector3 offset = new Vector3(0, 1.0f, 0);
            public TextMesh textMesh;
            public int MultiLifeCounter = 1;
            public GameObject taxi;
            public void Start()
            {
                Canvas canvas = otherGameObject.GetComponentInChildren<Canvas>();
                if (canvas == null)
                {
                    canvas = GameObject.Find("Canvas").GetComponent<Canvas>();
                }


                if (canvas != null)
                {

                    GameObject bob = new GameObject("Jmc");
                    bob.transform.SetParent(canvas.transform);
                    bob.transform.localPosition = Vector3.zero;
                    taxi = bob;
             
                    textMesh = bob.AddComponent<TextMesh>();
                    textMesh.text = "Lives: " + MultiLifeCounter;
                    textMesh.fontSize = 32; 
                    textMesh.characterSize = 0.05f; // Scale down the text
                    textMesh.offsetZ = -0.1f;  // textMesh.fontSize = 72; 
                    // textMesh.characterSize = 0.1f;
                    textMesh.alignment = TextAlignment.Center;
                    textMesh.color = Color.white;
                }
            }

            public void OnDestroy()
            {
                Destroy(taxi);
            }

                void Update()
            {
                if(gameObject.GetComponent<LimbBehaviour>().Health <= 0) {

                    if(MultiLifeCounter != 0)
                    {
                        Revive();
                        MultiLifeCounter--;
                    } 

                }

                 if (otherGameObject != null && textMesh != null)
                  {
                    // textMesh.transform.position = otherGameObject.transform.position;
                    textMesh.transform.position = otherGameObject.transform.position + offset;
                    textMesh.text = "Extra Lives: " + MultiLifeCounter;
                }

                 if(MultiLifeCounter == 0)
                {

                    StartCoroutine(Plastic());
                }
                 
            }

            private IEnumerator Plastic()
            {
                float eye = Time.time;
                float brain = eye + 1f;

                
                while (Time.time < brain)
                {
                    float progress = (Time.time - eye) / 1f;
                    Color color = taxi.GetComponent<Renderer>().material.color;
                    color.a = Mathf.Lerp(1f, 0f, progress);
                    taxi.GetComponent<Renderer>().material.color = color;
                    yield return null;
                }

                yield return new WaitForSeconds(1f);
                Destroy(taxi);
                Destroy(this);
            }

            public void Revive()
            {
                var person = gameObject.GetComponent<LimbBehaviour>().Person;

                foreach (var jmc in person.Limbs)
                {
                    jmc.IsZombie = false;
                    jmc.Health = jmc.InitialHealth;
                    jmc.Numbness = 0f;
                    jmc.HealBone();

                    jmc.Person.Braindead = false;
                    jmc.Person.BrainDamaged = false;
                    jmc.Person.Consciousness = 1f;
                    jmc.Person.ShockLevel = 0f;
                    jmc.Person.PainLevel = 0f;
                    jmc.Person.OxygenLevel = 1f;
                    jmc.Person.AdrenalineLevel = 0f;

                    CirculationBehaviour circulationBehaviour = jmc.CirculationBehaviour;
                    float amount = circulationBehaviour.GetAmount(jmc.GetOriginalBloodType());
                    if (amount < 0.1f)
                    {
                        circulationBehaviour.AddLiquid(jmc.GetOriginalBloodType(), 1f - amount);
                    }
                    circulationBehaviour.BloodFlow = 1f;
                    circulationBehaviour.HealBleeding();
                    circulationBehaviour.BleedingRate = 0f;
                    circulationBehaviour.IsPump = circulationBehaviour.WasInitiallyPumping;
                }
            }

        }

       

        



        }

        }
    
     
    





